"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var contracts_1 = require("./services/contracts");
var plan_api_1 = require("./apis/plan_api");
var subscriptions_api_1 = require("./apis/subscriptions_api");
var volume_subscription_wrapper_1 = require("./wrappers/volume_subscription_wrapper");
var executor_wrapper_1 = require("./wrappers/executor_wrapper");
var token_wrapper_1 = require("./wrappers/token_wrapper");
var blockchain_api_1 = require("./apis/blockchain_api");
var EightEx = /** @class */ (function () {
    function EightEx(web3, addressBook) {
        this.web3 = web3;
        this.addressBook = addressBook;
        this.contracts = new contracts_1.default(web3, addressBook);
        this.volumeSubscriptionWrapper = new volume_subscription_wrapper_1.default(web3, this.contracts);
        this.executorWrapper = new executor_wrapper_1.default(web3, this.contracts);
        this.tokenWrapper = new token_wrapper_1.default(web3, this.contracts);
        this.plans = new plan_api_1.default(web3, addressBook, this.volumeSubscriptionWrapper);
        this.subscriptions = new subscriptions_api_1.default(web3, addressBook, this.volumeSubscriptionWrapper, this.executorWrapper, this.tokenWrapper);
        this.blockchain = new blockchain_api_1.BlockchainAPI(web3);
    }
    return EightEx;
}());
exports.default = EightEx;
//# sourceMappingURL=index.js.map