import { ExecutorContract, VolumeSubscriptionContract, PaymentRegistryContract, MockTokenContract } from '@8xprotocol/artifacts';
import { AddressBook, Address } from '@8xprotocol/types';
import * as Web3 from 'web3';
export interface EightExContracts {
    executorContract: ExecutorContract;
    volumeVolumescription: VolumeSubscriptionContract;
    paymentRegistry: PaymentRegistryContract;
}
export default class Contracts {
    private web3;
    private addressBook;
    private cache;
    constructor(web3: Web3, addressBook: AddressBook);
    loadExecutor(): Promise<ExecutorContract>;
    loadPaymentRegistry(): Promise<PaymentRegistryContract>;
    loadVolumeSubscription(): Promise<VolumeSubscriptionContract>;
    loadERC20Token(address: Address): Promise<MockTokenContract>;
    private getERC20TokenCacheKey;
}
