import * as Web3 from 'web3';
import BigNumber from 'bignumber.js';
import { Address, TxData, TxHash } from '@8xprotocol/types';
import Contracts from '../services/contracts';
export default class TokenWrapper {
    private web3;
    private contracts;
    constructor(web3: Web3, contracts: Contracts);
    allowance(token: Address, owner: Address, spender: Address): Promise<BigNumber>;
    balanceOf(token: Address, user: Address): Promise<BigNumber>;
    giveApproval(token: Address, spender: Address, value: BigNumber, txData?: TxData): Promise<TxHash>;
}
