import * as Web3 from 'web3';
import Contracts from '../services/contracts';
import BigNumber from 'bignumber.js';
import { Address, Bytes32, TxData, TxHash, Plan, Subscription } from '@8xprotocol/types';
export default class VolumeSubscriptionWrapper {
    private web3;
    private contracts;
    private web3Utils;
    constructor(web3: Web3, contracts: Contracts);
    createPlan(owner: Address, token: Address, identifier: string, interval: number, amount: BigNumber, fee: BigNumber, name: string | null, description: string | null, imageUrl: string | null, metaData: JSON | null, txData?: TxData): Promise<Bytes32>;
    terminatePlan(identifier: Bytes32, txData?: TxData): Promise<TxHash>;
    getPlan(planHash: Bytes32): Promise<Plan>;
    getPlans(owner: string): Promise<Plan[]>;
    getSubscriptionsByUser(user: Address): Promise<Subscription[]>;
    getSubscriptionsByPlan(planHash: Bytes32): Promise<Subscription[]>;
    private getSubscribersBy;
    subscribeAndActivate(planHash: Bytes32, metaData: JSON | null, txData?: TxData): Promise<Bytes32>;
    createSubscription(planHash: Bytes32, metaData: JSON | null, txData?: TxData): Promise<Bytes32>;
    cancelPayment(subscriptionHash: Bytes32, txData?: TxData): Promise<TxHash>;
    getSubscription(subscriptionHash: Bytes32): Promise<Subscription>;
    getSubscriptionState(subscriptionHash: Bytes32): Promise<void>;
}
