"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var abi = require("ethereumjs-abi");
var bignumber_js_1 = require("bignumber.js");
var artifacts_1 = require("@8xprotocol/artifacts");
var transaction_utils_1 = require("../utils/transaction_utils");
var logs_1 = require("../utils/logs");
var VolumeSubscriptionWrapper = /** @class */ (function () {
    function VolumeSubscriptionWrapper(web3, contracts) {
        this.web3 = web3;
        this.contracts = contracts;
        this.web3Utils = new artifacts_1.Web3Utils(this.web3);
    }
    VolumeSubscriptionWrapper.prototype.createPlan = function (owner, token, identifier, interval, amount, fee, name, description, imageUrl, metaData, txData) {
        return __awaiter(this, void 0, void 0, function () {
            var txSettings, volumeSubscription, submitData, submitString, txHash, logs, planHash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, transaction_utils_1.generateTxOpts(this.web3, txData)];
                    case 1:
                        txSettings = _a.sent();
                        return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 2:
                        volumeSubscription = _a.sent();
                        submitData = metaData || {};
                        if (name) {
                            submitData['name'] = name;
                            submitData['description'] = description;
                            submitData['imageUrl'] = imageUrl;
                        }
                        submitString = (Object.keys(submitData).length > 0) ? JSON.stringify(submitData) : '';
                        return [4 /*yield*/, volumeSubscription.createPlan.sendTransactionAsync(owner, token, artifacts_1.Web3Utils.asciiToHex(identifier), new bignumber_js_1.default(interval), amount, fee, submitString, txSettings)];
                    case 3:
                        txHash = _a.sent();
                        return [4 /*yield*/, logs_1.getFormattedLogsFromTxHash(this.web3, artifacts_1.VolumeSubscriptionAbi.abi, txHash)];
                    case 4:
                        logs = _a.sent();
                        planHash = _.get(logs[0].args, "planIdentifier") || '';
                        return [2 /*return*/, planHash];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.terminatePlan = function (identifier, txData) {
        return __awaiter(this, void 0, void 0, function () {
            var txSettings, volumeSubscription;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, transaction_utils_1.generateTxOpts(this.web3, txData)];
                    case 1:
                        txSettings = _a.sent();
                        return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 2:
                        volumeSubscription = _a.sent();
                        return [4 /*yield*/, volumeSubscription.terminatePlan.sendTransactionAsync(identifier, new bignumber_js_1.default(Date.now()).dividedToIntegerBy(1000).add(60 * 60 * 24), txSettings)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.getPlan = function (planHash) {
        return __awaiter(this, void 0, void 0, function () {
            var volumeSubscription, _a, owner, tokenAddress, identifier, interval, amount, fee, data, terminationDate, parsedData, name, description, imageUrl;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 1:
                        volumeSubscription = _b.sent();
                        return [4 /*yield*/, volumeSubscription.plans.callAsync(planHash)];
                    case 2:
                        _a = _b.sent(), owner = _a[0], tokenAddress = _a[1], identifier = _a[2], interval = _a[3], amount = _a[4], fee = _a[5], data = _a[6], terminationDate = _a[7];
                        ;
                        identifier = artifacts_1.Web3Utils.hexToUtf8(identifier);
                        parsedData = JSON.parse(data);
                        if (parsedData) {
                            name = parsedData["name"] || '';
                            description = parsedData["description"] || '';
                            imageUrl = parsedData["imageUrl"] || '';
                        }
                        return [2 /*return*/, {
                                owner: owner,
                                tokenAddress: tokenAddress,
                                identifier: identifier,
                                interval: interval.toNumber(),
                                amount: amount,
                                fee: fee,
                                data: data,
                                terminationDate: terminationDate.toNumber(),
                                name: name,
                                description: description,
                                imageUrl: imageUrl,
                                planHash: planHash
                            }];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.getPlans = function (owner) {
        return __awaiter(this, void 0, void 0, function () {
            var volumeSubscription, logs, filteredLogs, ids, plans;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 1:
                        volumeSubscription = _a.sent();
                        return [4 /*yield*/, logs_1.getPastLogs(this.web3, volumeSubscription, 'CreatedPlan')];
                    case 2:
                        logs = _a.sent();
                        filteredLogs = logs.filter(function (object) {
                            return object['args']['owner'] == owner;
                        });
                        ids = filteredLogs.map(function (object) { return _.get(object, 'args.planIdentifier'); });
                        plans = ids.map(function (id) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.getPlan(id)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); });
                        return [4 /*yield*/, Promise.all(plans)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.getSubscriptionsByUser = function (user) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSubscribersBy('owner', user)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.getSubscriptionsByPlan = function (planHash) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSubscribersBy('planIdentifier', planHash)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.getSubscribersBy = function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var volumeSubscription, logs, ids, subscriptions;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 1:
                        volumeSubscription = _a.sent();
                        return [4 /*yield*/, logs_1.getPastLogs(this.web3, volumeSubscription, 'CreatedSubscription')];
                    case 2:
                        logs = _a.sent();
                        ids = logs.filter(function (object) {
                            return object['args'][key] == value;
                        }).map(function (object) {
                            var filterKey = _.get(object, "args." + key);
                            return filterKey == value ? _.get(object, 'args.paymentIdentifier') : null;
                        }).filter(function (object) { return object; });
                        subscriptions = ids.map(function (id) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.getSubscription(id)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); });
                        return [4 /*yield*/, Promise.all(subscriptions)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.subscribeAndActivate = function (planHash, metaData, txData) {
        return __awaiter(this, void 0, void 0, function () {
            var txSettings, volumeSubscription, executor, salt, computedSubscriptionHash, txHash, logs, subscriptionHash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, transaction_utils_1.generateTxOpts(this.web3, txData)];
                    case 1:
                        txSettings = _a.sent();
                        return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 2:
                        volumeSubscription = _a.sent();
                        return [4 /*yield*/, this.contracts.loadExecutor()];
                    case 3:
                        executor = _a.sent();
                        salt = ((Date.now() / 1000) + (Math.random() * 10000)).toFixed();
                        computedSubscriptionHash = "0x" + abi.soliditySHA3(["address", "bytes32", "uint256"], [txSettings.from, planHash, salt]).toString('hex');
                        return [4 /*yield*/, volumeSubscription.createSubscriptionAndCall.sendTransactionAsync(planHash, metaData ? JSON.stringify(metaData) : '', new bignumber_js_1.default(salt), executor.address, 'activateSubscription(address,bytes32)', txSettings)];
                    case 4:
                        txHash = _a.sent();
                        return [4 /*yield*/, logs_1.getFormattedLogsFromTxHash(this.web3, artifacts_1.VolumeSubscriptionAbi.abi, txHash)];
                    case 5:
                        logs = _a.sent();
                        subscriptionHash = _.get(logs[0].args, "paymentIdentifier") || '';
                        return [2 /*return*/, subscriptionHash];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.createSubscription = function (planHash, metaData, txData) {
        return __awaiter(this, void 0, void 0, function () {
            var txSettings, volumeSubscription, txHash, logs, subscriptionHash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, transaction_utils_1.generateTxOpts(this.web3, txData)];
                    case 1:
                        txSettings = _a.sent();
                        return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 2:
                        volumeSubscription = _a.sent();
                        return [4 /*yield*/, volumeSubscription.createSubscription.sendTransactionAsync(planHash, metaData ? JSON.stringify(metaData) : '', txSettings)];
                    case 3:
                        txHash = _a.sent();
                        return [4 /*yield*/, logs_1.getFormattedLogsFromTxHash(this.web3, artifacts_1.VolumeSubscriptionAbi.abi, txHash)];
                    case 4:
                        logs = _a.sent();
                        subscriptionHash = _.get(logs[0].args, "paymentIdentifier") || '';
                        return [2 /*return*/, subscriptionHash];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.cancelPayment = function (subscriptionHash, txData) {
        return __awaiter(this, void 0, void 0, function () {
            var txSettings, volumeSubscription;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, transaction_utils_1.generateTxOpts(this.web3, txData)];
                    case 1:
                        txSettings = _a.sent();
                        return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 2:
                        volumeSubscription = _a.sent();
                        return [4 /*yield*/, volumeSubscription.cancelPayment.sendTransactionAsync(subscriptionHash, txSettings)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.getSubscription = function (subscriptionHash) {
        return __awaiter(this, void 0, void 0, function () {
            var volumeSubscription, _a, owner, tokenAddress, planHash, lastPaymentDate, terminationDate, data;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.contracts.loadVolumeSubscription()];
                    case 1:
                        volumeSubscription = _b.sent();
                        return [4 /*yield*/, volumeSubscription.subscriptions.callAsync(subscriptionHash)];
                    case 2:
                        _a = _b.sent(), owner = _a[0], tokenAddress = _a[1], planHash = _a[2], lastPaymentDate = _a[3], terminationDate = _a[4], data = _a[5];
                        return [2 /*return*/, {
                                owner: owner,
                                tokenAddress: tokenAddress,
                                planHash: planHash,
                                lastPaymentDate: lastPaymentDate.toNumber(),
                                terminationDate: terminationDate.toNumber(),
                                data: data,
                                subscriptionHash: subscriptionHash
                            }];
                }
            });
        });
    };
    VolumeSubscriptionWrapper.prototype.getSubscriptionState = function (subscriptionHash) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    return VolumeSubscriptionWrapper;
}());
exports.default = VolumeSubscriptionWrapper;
//# sourceMappingURL=volume_subscription_wrapper.js.map